function build_tag_button(tag, name, callback){
        var btn = document.createElement(TAG_BUTTON);
        btn.classList.add(CLASS_BUTTON);
        btn.classList.add(CLASS_TAG);
        btn.onclick = callback.bind(this, name, btn); // toggle_tag
        btn.id = CLASS_TAG + tag
        btn.appendChild(document.createTextNode(name));
        return btn;
}

function build_button(name, callback, special_class){
        var btn = document.createElement(TAG_BUTTON);
        btn.className = special_class;
        btn.classList.add(CLASS_BUTTON);
        btn.onclick = callback;
        btn.appendChild(document.createTextNode(name));
        return btn;
}

function build_content(root, data, callback){
        // Tags
        for (t in data[JSON_TAGS])
            if (Tags.includes(data[JSON_TAGS][t]) == false){
                Tags.push(data[JSON_TAGS][t]);
                Tag_objects[data[JSON_TAGS][t]] = false;
            }

        // Icon
        var icon = document.createElement(TAG_IMG);
        icon.src = data[JSON_icon];
        icon.alt = JSON_icon;

        // Name
        var headline = document.createElement(TAG_HEADLINE);
        headline.appendChild(document.createTextNode(data[JSON_name]));

        if ((callback !== null) && (callback !== undefined)){
                headline.onclick = callback;
                icon.onclick =callback;
        }

        // Body
        var body = document.createElement(TAG_P);
        body.appendChild(document.createTextNode(data[JSON_body]));

        // References
        var refs = document.createElement(TAG_P);
        for (r in data[JSON_references]){
                var a = document.createElement(TAG_A);
                var text =  data[JSON_references][r][JSON_description];
                a.appendChild(document.createTextNode("» " +text));
                a.title = text;
                a.href = data[JSON_references][r][JSON_link];
                a.target = A_TARGET;
                refs.appendChild(a);
        }
        root.appendChild(icon);
        root.appendChild(headline);
        root.appendChild(body);
        root.appendChild(refs);
}




function create_item(id, data){
// Name
var headline = document.createElement(TAG_ITEM_HEADLINE);
headline.appendChild(document.createTextNode(TEXT_MASSNAHMEN));

// Type
var col_1 = document.createElement(TAG_DIV);
col_1.className = CLASS_COL
var col_1_headline = document.createElement(TAG_ITEM_ACTION_HEADLINE);
col_1_headline.appendChild(document.createTextNode(TEXT_PREVENTION));
col_1.appendChild(col_1_headline)
col_1.appendChild(document.createTextNode(data[JSON_prevention]));

// "Detection"
var col_2 = document.createElement(TAG_DIV);
col_2.className = CLASS_COL
var col_2_headline = document.createElement(TAG_ITEM_ACTION_HEADLINE);
col_2_headline.appendChild(document.createTextNode(TEXT_DETECTION));
col_2.appendChild(col_2_headline)
col_2.appendChild(document.createTextNode(data[JSON_detection]));

// "Reaction"
var col_3 = document.createElement(TAG_DIV);
col_3.className = CLASS_COL
var col_3_headline = document.createElement(TAG_ITEM_ACTION_HEADLINE);
col_3_headline.appendChild(document.createTextNode(TEXT_REACTION));
col_3.appendChild(col_3_headline)
col_3.appendChild(document.createTextNode(data[JSON_reaction]));

var action = document.createElement(TAG_DIV);
action.className = CLASS_MASSNAHMEN
action.id = CLASS_MASSNAHMEN + WHITESPACE + id
action.appendChild(headline);
action.appendChild(col_1);
action.appendChild(col_2);
action.appendChild(col_3);

return action;
}
